library DemoDll;


uses
  SysUtils,
  Classes, BufferDef, Forms, dialogs,
  dmU in 'dmU.pas' {dm1: TDataModule};

{$R *.RES}


procedure Load(buf: TRPCBuffer);
begin
  try
  //Create DataModule if not created
    if not assigned(dm1) then
      dm1 := TDm1.Create(nil);
    dm1.Table1.open;
    dm1.table1.first;
    while not dm1.table1.Eof do
    begin
      //write each Country Name into separate record of Buffer
      buf.WriteFields(true, [dm1.table1.fieldbyname('Name').asString]);
      dm1.table1.next;
    end;
    dm1.table1.close;
  finally
    //Release DataModule from memory
    if assigned(dm1) then freeAndNil(dm1);
  end;
end;

procedure Get(s: string; buf: TRPCBuffer);
var
	i: Integer;
begin
  if not Assigned(dm1) then
    dm1 := TDm1.Create(nil);
  try
    dm1.Table1.open;
    //Locate record where country name is in S)
    if not dm1.table1.locate('Name', s, []) then exit else
    begin
    //write all fields in separate records of buffer
      for i := 0 to dm1.table1.FieldCount - 1 do
        buf.WriteFields(true, [dm1.table1.fields[i].asString]);
      dm1.table1.close;
    end;
  finally
    if assigned(dm1) then FreeAndNil(dm1);
  end;
end;

procedure SendCommand(buf: PChar; Len: Integer; Output: PChar); stdcall;
var
  s1, s2: string;
  inBuffer: TRPCBuffer;
  outBuffer: TRPCBuffer;
begin
  //Create in and out buffer
  inBuffer := TRPCBuffer.create;
  outBuffer := TRPCBuffer.create;
  try
   //initialize buffers
    inBuffer.Rewrite;
    outBuffer.Rewrite;
    //Adjust length of InBuffer
    if Len > inBuffer.DataBufferSize then
      inBuffer.DataBufferSize := Len;
    inBuffer.DataBufferCount := Len;
    //Load the length into the buffer
    Move( buf^ , inBuffer.DataBuffer^ , Len );
    //Go to the first record of the buffer
    inBuffer.first;

    //read first field which is in our case command
    s1 := inBuffer.Fields[0];
    //If command is LOAD, get all country names. Procedure LOAD does it
    // and put the result into OutBuffer
    if s1 = 'LOAD' then load(OutBuffer);

    // If command is GET, read second field which is a country name
    // and pass it to the procedure GET, loading result into outBuffer
    if s1 = 'GET' then
    begin
      s2 := inBuffer.fields[1];
      get(s2, OutBuffer);
    end;

    //Put the result into the OutPut variable so it doesn't get
    //killed by commands in Finally block
    Move(OutBuffer.DataBuffer^, OutPut^, OutBuffer.DataBufferSize);

  finally
   //Release buffers
    inBuffer.free;
    outBuffer.free;
  end;
end;

exports
  SendCommand;
begin
end.

